/* microval (version 2)
 * Hudson Lacerda (2004-2005)
 *
 * Calcula valores para nomes de acidentes microtonais para abcm2ps
 *
 * Calculate values for abcm2ps' microtone accidental function names
 */

/* Defina a macro abaixo para obter o programa em portugus.*/
/* #define PORTUGUES */

#include <stdio.h>
#include <stdlib.h>
int main (int argc, char *argv[]) {
	float x=0.0, y=0.0;
	if(argc!=3 && argc!=2) {
		printf("\n\tmicroval (Hudson Lacerda - 2004-2005)\n\n");
#ifdef PORTUGUES
		printf("\t um programa para calcular o valor a ser utilizado"
		       "\n"
		       "\tna definio de acidentes microtonais para abcm2ps."
		       "\nD\n"
		       "FORMAS DE USO:\n\nmicroval <numerator> <denominator>\n"
		       "\tImprime <micro_value>, o nmero a utilizar no nome"
		       " da funo.\n\n"
		       "microval <micro_value>\n"
		       "\tImprime os valores de <numerator> e <denominator>."
		       "\n\n");
#else
		printf("\tis a program to calculate the value to be used in\n"
		       "\tabcm2ps' microtone accidental definitions.\n\n"
		       "USAGE:\n\nmicroval <numerator> <denominator>\n"
		       "\tPrint <micro_value>, the number to be used in "
		       "the function name.\n\n"
		       "microval <micro_value>\n"
		       "\tPrint the values of <numerator> and <denominator>"
		       "\n\n");
#endif
		return 0;
	}

	x=atof(argv[1]);
	if (argc==3) {
		y=atof(argv[2]);
		if(x>256.0 || y>256.0 || x<1 || y<1) {
#ifdef PORTUGUES
			printf(
			       "ERRO: <numerator> e <denominator> devem ser"
			       " nmeros inteiros de 1 a 256\n");
#else
			printf(
			       "ERROR: <numerator> and <denominator> must be"
			       " integers from 1 to 256\n");
#endif
			return 0;
		}
		printf("<micro_value> = %ld\n",
		       (long int)((256.0 * (x-1.0)) + (y-1.0)));
	}
	else { /* argc==2 */
		if(x>65535.0 || x <0) {
#ifdef PORTUGUES
			printf("ERRO: <micro_value> no pode ser"
			       " negativo ou maior que 65535\n");
#else
			printf("ERROR: <micro_value> cannot be"
			       " negative or greater than 65535\n");
#endif
			return 0;
		}
		printf("<numerator>   = %ld\n", 1L+(((long int)x)/256L));
		printf("<denominator> = %ld\n", 1L+(((long int)x)%256L));
	}

	return 0;
}
